<template>
  <div>
    <el-table :data="studentEstimateQuestionList" height="400">
        <el-table-column type="index" :label="$t('STUDENT_MENU.NUMBER')" align="center" width="100">
        </el-table-column>
        <el-table-column prop="type" :label="$t('QUESTION.TYPE')" align="center" width="150">
        </el-table-column>
        <el-table-column prop="name" :label="$t('QUESTION.QUES_NAME')" align="center" width="200">
        </el-table-column>
        <el-table-column prop="estimated" :label="$t('STUDENT_ASSIGNMENT.SCORE_STATUS')" align="center" width="350">
        </el-table-column>
       
        <el-table-column :label="$t('STUDENT_ASSIGNMENT.EVALUATE')" align="center" width="130">
          <template slot-scope="scope">
            <el-button size="small" @click="onClick('ESTIMATE', scope.$index)">{{ $t('STUDENT_ASSIGNMENT.EVALUATE') }}</el-button>
          </template>
        </el-table-column>
        
      </el-table>

      <el-dialog :visible.sync="dialogVisible" :title="$t('STUDENT_ASSIGNMENT.QUES_EVAL')" :before-close="handleClose" center width="50%">
        <quiz-estimate :question="currentQuestion"></quiz-estimate>
          <el-button @click="handleClose" style="margin-top:15px;">{{ $t('DASHBOARD.QUIT') }}</el-button>
      </el-dialog>

  </div>
</template>

<script>
import { mapState, mapActions, mapMutations } from 'vuex';
import { getIdFromURL } from 'vue-youtube-embed';
import QuizPreview from '../partials/QuizPreview';
import QuizEstimate from '../partials/QuizEstimate';
import lectureService from '../../services/lectureService';
import { spawn } from 'child_process';
import  utils from '../../utils';

export default {
  name: 'StudentSelfQuizEstimate',
  components: {
    QuizPreview,
    QuizEstimate,
  },
  data() {
    return {
      currentQuestion: null,
      numQuiz: 0,
    };
  },
  computed: {
    ...mapState({
      index: state => state.studentQuestion.index,
      studentEstimateQuestionList: state => state.studentQuestion.studentEstimateQuestionList,
      mode: state => state.studentQuestion.mode,
      lectureHomework: state => state.studentQuestion.lectureHomework,
      studentQuestionKeywords: state => state.studentQuestion.studentQuestionKeywords,
      dialogVisible: state => state.studentQuestion.dialogVisible,
    }),
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.query.lectureId, 10);
    },
  },
  async created() {
    const vm = this;
    const lectureId = vm.lectureId;
    vm.updateStudentEstimateQuestionList([]);
    await vm.getSudentEstimateQuestionList({ id: lectureId });

    const res4 = await lectureService.loadStudentSubmitResult({
      lectureId,
    });
    if (res4.statusText == 'OK') {
      vm.numQuiz = res4.data.length;
    }
    const studentId = await utils.getUserIdFromJwt();
    const res5 = await lectureService.getThisStudentEstimated({
      lectureId, 
      studentId,
    });
    for (let i = 0; i < res5.data.length; i++) {
      const res6 = await lectureService.getEstimatedQuestion({
        questionId: res5.data[i].student_question_id,
      });
      let flag = true;
      vm.studentEstimateQuestionList.forEach((q) => {
        if (q.student_question_id === res6.data[0].student_question_id) flag = false;
      })
      if (flag) {
        const answer = res6.data[0].answer;
        const choice =  res6.data[0].choice;
        res6.data[0].answer = [];
        res6.data[0].choice = [];
        if (answer.includes('<$!<>')) {
          const spl = answer.split('<$!<>');
          spl.forEach((x) => {
            res6.data[0].answer.push(x);
          });
        } else res6.data[0].answer.push(answer);
        if (choice != undefined && choice.includes('<$!<>')) {
          const spl = choice.split('<$!<>');
          spl.forEach((x) => {
            res6.data[0].choice.push(x);
          });
        } else res6.data[0].choice.push(choice);
        res6.data[0].estimated = "완료";
        if (res6.data[0].type === 1) res6.data[0].type = "단답";
        else if (res6.data[0].type === 0) res6.data[0].type = "객관";
        else if (res6.data[0].type === 2) res6.data[0].type = "파일";
        vm.studentEstimateQuestionList.push(res6.data[0]);
      }
    }
  },
  methods: {
    ...mapActions('studentQuestion', [
      'getQuestionList',
      'deleteQuestion',
      'transferStudentQuestion',
      'getSudentEstimateQuestionList',
      'getSudentEstimateQuestionList',
      'getStudentQuestionKeywords',
    ]),
    ...mapMutations('studentQuestion', [
      'updateStudentQuestionIndex',
      'updateStudentQuestionIndex',
      'updateStudentQuestionMode',
      'updateDialogVisible',
      'updateStudentEstimateQuestionList'
    ]),
    youtubeId(URL) {
      return URL !== undefined ? getIdFromURL(URL) : '';
    },
    async onClick(type, index) {
      const vm = this;
      const q = vm.studentEstimateQuestionList[index];
      // 2020.05.26 이제 재평가 가능
      // if (q.estimated === '완료') {
      //   vm.$notify({
      //     title: vm.$t('NOTIFY.ESTIMATE_FINISH'),
      //     message: vm.$t('NOTIFY.ALRDY_EVAL_QUES'),
      //     type: 'error',
      //   });
      //   return;
      // }

      await vm.getStudentQuestionKeywords({ id: vm.lectureId, qId: q.student_question_id });

      switch (type) {
        case 'ESTIMATE': {
          vm.updateDialogVisible({ value: true });
          vm.currentQuestion = q;
          break;
        }
        default : {
          break;
        }
      }
    },
    handleClose() {
      const vm = this;
      vm.updateDialogVisible({ value: false });
    },
  },
};
</script>